local _, MonkTimers = ...

local L = LibStub("AceLocale-3.0"):GetLocale("MonkTimers_GUI", true)

local SpellIDs = MonkTimers.SpellIDs
local SpellNames = MonkTimers.SpellNames


local function OrderTimers(role)
    for i = 1,#MonkTimers.ActiveProfile.Timers_Order[tonumber(role)] do
        if MonkTimers.options.args.timers.args[role].args[tostring(MonkTimers.ActiveProfile.Timers_Order[tonumber(role)][i])] then
            MonkTimers.options.args.timers.args[role].args[tostring(MonkTimers.ActiveProfile.Timers_Order[tonumber(role)][i])].order = i+10
        end
    end
end

local function changeOrder(spell, dir, role)
    role = tonumber(role)
    for i=1,MonkTimers.num_CD_Spells[role] do
        if MonkTimers.ActiveProfile.Timers_Order[role][i] == spell and i+dir>0 and i+dir<=MonkTimers.num_CD_Spells[role] then
            MonkTimers.ActiveProfile.Timers_Order[role][i],MonkTimers.ActiveProfile.Timers_Order[role][i+dir] =
                    MonkTimers.ActiveProfile.Timers_Order[role][i+dir],MonkTimers.ActiveProfile.Timers_Order[role][i]
            break
        end
    end
    OrderTimers(tostring(role))
    MonkTimers.ProcessSetting("Timers")
end

MonkTimers.options.args.timers = {
    type = "group",
    name = "enhancecds",
    args = {
       --[[ enable = {
            order = 0,
            type = "toggle",
            name = L["Enable"],
            set = function(info, val) MonkTimers.ActiveProfile.Timers = val  MonkTimers.ProcessSetting("Timers") end,
            get = function(info) return MonkTimers.ActiveProfile.Timers end,
        },]]
       --[[ header = {
            order = 10,
            type = "header",
            name = "",
        }, ]]   
        clickthrough = {
            order = 1,
            type = "toggle", 
            name = L["Clickthrough"],
            desc = L["Clickthrough Desc"],
            set = function(info, val) MonkTimers.ActiveProfile.TimersClickthrough = val  MonkTimers.ProcessSetting("TimersClickthrough") end,
            get = function(info) return MonkTimers.ActiveProfile.TimersClickthrough end,
        },
        TimersOnButtons = {
            order = 11,
            type = "toggle",
            name = L["Timers On Buttons"],
            set = function(info, val) MonkTimers.ActiveProfile.TimersOnButtons = val
                        MonkTimers.ProcessSetting("TimersOnButtons") end,
            get = function(info) return MonkTimers.ActiveProfile.TimersOnButtons end,
        },  
        HideTimersOOC = {
            order = 12,
            type = "toggle",
            name = L["Hide out of combat"],
            desc = L["Hide OOC Desc"],
            set = function(info, val) MonkTimers.ActiveProfile.HideTimersOOC = val  MonkTimers.ProcessSetting("HideTimersOOC") end,
            get = function(info) return MonkTimers.ActiveProfile.HideTimersOOC end,
        }, 
        OOCAlpha = {
            order = 13,
            type="range",
            min = 0,
            max = 1,
            step = 0.1,
            name = L["OOC Alpha"], 
            desc = L["OOC Alpha Desc"],
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimersOOCAlpha = val  MonkTimers.ProcessSetting("TimersOOCAlpha")	
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimersOOCAlpha end,
        },
        --[[scaling = {
            order = 20,
            type = "header",
            name = "Scaling",
        },]]
        Size = {
            order = 21,
            type = "range",
            name = L["Button Size"] ,
            min = 16,
            max = 96,
            step = 1,
            bigStep = 2,
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimersSize = val  MonkTimers.ProcessSetting("TimersSize")	
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimersSize end,
        },
        fontSize = {
            order = 22,
            type = "range",
            name = L["Font Size"],
            min = 6,
            max = 40,
            step = 1,
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimersTimeHeight = val  MonkTimers.ProcessSetting("TimersTimeHeight")	
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimersTimeHeight end,
        },
        ["1"] = {
            order = 30,
            type = "group",
            name = select(2,GetSpecializationInfo(1)) or "Brewmaster",
            args = {
                tigerpalm = {
                    order = 1,
                    type = "toggle",
                    name = SpellNames[SpellIDs.TigerPalm],
                    set = function(info, val) MonkTimers.ActiveProfile.Timer_Spells[1][1] = val  MonkTimers.ProcessSetting("Timers") end,
                    get = function(info) return MonkTimers.ActiveProfile.Timer_Spells[1][1] end,
                },
                blackoutkick = {
                    order = 2,
                    type = "toggle",
                    name = SpellNames[SpellIDs.BlackoutKick].."/"..SpellNames[SpellIDs.Shuffle],
                    set = function(info, val) MonkTimers.ActiveProfile.Timer_Spells[1][2] = val  MonkTimers.ProcessSetting("Timers") end,
                    get = function(info) return MonkTimers.ActiveProfile.Timer_Spells[1][2] end,
                },
                elusivebrew = {
                    order = 3,
                    type = "toggle",
                    name = SpellNames[SpellIDs.ElusiveBrew],
                    set = function(info, val) MonkTimers.ActiveProfile.Timer_Spells[1][3] = val  MonkTimers.ProcessSetting("Timers") end,
                    get = function(info) return MonkTimers.ActiveProfile.Timer_Spells[1][3] end,
                },
            },
        },
        ["2"] = {
            order = 40,
            type = "group",
            name = select(2,GetSpecializationInfo(2)) or "Windwalker",
            args = {
                tigerpalm = {
                    order = 1,
                    type = "toggle",
                    name = SpellNames[SpellIDs.TigerPalm],
                    set = function(info, val) MonkTimers.ActiveProfile.Timer_Spells[2][1] = val  MonkTimers.ProcessSetting("EnhanceCDs") end,
                    get = function(info) return MonkTimers.ActiveProfile.Timer_Spells[2][1] end,
                },
            },
        },
        ["3"] = {
            order = 50,
            type = "group",
            name = select(2,GetSpecializationInfo(3)) or "Mistweaver",
            args = {
                riptide = {
                    order = 1,
                    type = "toggle",
                    name = SpellNames[SpellIDs.TigerPalm],
                    set = function(info, val) MonkTimers.ActiveProfile.Timer_Spells[3][1] = val  MonkTimers.ProcessSetting("Timers") end,
                    get = function(info) return MonkTimers.ActiveProfile.Timer_Spells[3][1] end,
                },
            },
        }, 
    },
}
    
local ACD = LibStub("AceConfigDialog-3.0")
local frame = ACD:AddToBlizOptions("MonkTimers", L["Timers"], "MonkTimers", "timers")    
frame:SetScript("OnEvent", function(self) InterfaceOptionsFrame:Hide() end)
frame:HookScript("OnShow", function(self) if InCombatLockdown() then InterfaceOptionsFrame:Hide() end MonkTimers.LastGUIPanel = self end)
frame:RegisterEvent("PLAYER_REGEN_DISABLED")